<template>
  <div>
    <div v-show="!switchItems">
      <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
        <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
          <a-row :gutter="24">
            <a-col :lg="6">
              <a-form-item :label="searchFormSchema[0].label">
                <JInput type="like" placeholder="请输入关键字" v-model:value="queryParam[searchFormSchema[0].field]" allowClear="true" />
              </a-form-item>
            </a-col>
          </a-row>
          <a-row :gutter="24">
            <a-col :lg="6">
              <a-form-item :label="searchFormSchema[1].label">
                <a-checkbox-group
                  style="width: 800px"
                  v-model:value="queryParam[searchFormSchema[1].field]"
                  :options="checkOptionStatus"
                  @change="(data) => onCheckChange(data, 'checkStatus')"
                />
              </a-form-item>
            </a-col>
          </a-row>
          <a-row :gutter="24">
            <a-col :lg="6">
              <a-form-item :label="searchFormSchema[2].label">
                <a-checkbox-group
                  style="width: 800px"
                  v-model:value="queryParam[searchFormSchema[2].field]"
                  :options="checkOptionDates"
                  @change="(data) => onCheckChange(data, 'checkDates')"
                />
              </a-form-item>
            </a-col>
          </a-row>
          <a-row :gutter="24">
            <a-col :lg="6">
              <a-form-item :label="searchFormSchema[3].label">
                <a-checkbox-group
                  style="width: 800px"
                  v-model:value="queryParam[searchFormSchema[3].field]"
                  :options="checkOptionClassifys"
                  @change="(data) => onCheckChange(data, 'checkClassifys')"
                />
              </a-form-item>
            </a-col>
            <a-col :lg="6" :offset="12">
              <a-form-item>
                <a-space :size="5">
                  <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                  <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset">重置</a-button>
                </a-space>
              </a-form-item>
            </a-col>
          </a-row>
        </a-form>
        <!--引用表格-->
        <BasicTable @register="registerTable" :rowSelection="rowSelection">
          <!--插槽:table标题-->
          <template #tableTitle>
            <a-button v-show="showBtn" type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
            <a-button v-show="showBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
            <j-upload-button v-show="showBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
            <a-dropdown v-if="selectedRowKeys.length > 0 && showBtn">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined" />
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button
                >批量操作
                <Icon icon="mdi:chevron-down" />
              </a-button>
            </a-dropdown>
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'fileName'">
              <JEllipsisFormat :isLink="true" :value="record.fileName" :length="60" @click="goToPage(record)" />
            </template>
            <template v-else-if="column.key === 'applyRangeNamestr'">
              <JEllipsisFormat :value="!record.applyRangeNamestr ? '-' : record.applyRangeNamestr" :length="60" />
            </template>
            <template v-else-if="column.key === 'fileUploadPath'">
              <a-button type="link" v-for="(item, index) in parsePathsValue(record.fileUploadPath)" :key="index" :href="item.url" target="_blank">
                {{ item.name }}
              </a-button>
            </template>
          </template>
          <!--操作栏-->
          <template #action="{ record }">
            <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
          </template>
          <!--字段回显插槽-->
          <template #htmlSlot="{ text }">
            <div v-html="text"></div>
          </template>
          <!--省市区字段回显插槽-->
          <template #pcaSlot="{ text }">
            {{ getAreaTextByCode(text) }}
          </template>
          <template #fileSlot="{ text }">
            <span v-if="!text" style="font-size: 12px; font-style: italic">无文件</span>
            <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)"
              >下载</a-button
            >
          </template>
        </BasicTable>
      </div>
      <!-- 表单区域 -->
      <StComplianeInfoModal @register="registerModal" @success="handleSuccess" :showfotterflag="false" />
    </div>
  </div>
</template>

<script lang="ts" name="standardlib-compliane-query" setup>
  import { onMounted, reactive, ref, toRaw, unref } from 'vue';
  import { useRoute, useRouter } from 'vue-router';
  import JEllipsisFormat from '../components/JEllipsisFormat.vue';
  import { batchDelete, deleteOne, getExportUrl, getImportUrl, listAll } from './StComplianeInfo.api';
  import { columns, searchFormSchema } from './StComplianeInfoquery.data';
  import StComplianeInfoModal from './components/StComplianeInfoModal.vue';
  import { getDictItems } from '/@/api/common/api';
  import { JInput } from '/@/components/Form';
  import { useModal } from '/@/components/Modal';
  import { BasicTable, TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { getFileAccessHttpUrl } from '/@/utils/common/compUtils';
  import { downloadFile } from '/@/utils/common/renderUtils';
  const showBtn = ref(false);
  const checkedKeys = ref<Array<string | number>>([]);
  var ckFlag = reactive({
    checkStatus: true,
    checkDates: true,
    checkClassifys: true,
  });
  const checkOptionStatus = ref([{ label: '全部', value: 'all' }]);
  const checkOptionDates = ref([
    { label: '全部', value: 'all' },
    { label: '近一年', value: '1' },
    { label: '近两年', value: '2' },
    { label: '近三年', value: '3' },
    { label: '三年以上', value: '4' },
  ]);
  const checkOptionClassifys = ref([
    { label: '全部', value: 'all' },
    { label: '法律', value: '1' },
    { label: '法规', value: '2' },
    { label: '监管意见', value: '3' },
    { label: '风险提示', value: '4' },
    { label: '处罚通知', value: '5' },
  ]);
  function initOptions() {
    getDictItems('filestatus').then((res) => {
      let opt = [{ label: '全部', value: 'all' }];
      for (let i in res) {
        opt.push(res[i]);
      }
      checkOptionStatus.value = opt;
    });
  }
  onMounted(() => {
    if (checkOptionStatus.value.length === 1) {
      initOptions();
    }
  });
  function onCheckChange(checkedValue, key) {
    var index = checkedValue.length;
    if (index > 0) {
      if (ckFlag[key]) {
        const otherCb = [];
        checkedValue.forEach((item) => {
          if (item != 'all') {
            otherCb.push(item);
          }
        });
        let assignItem = {};
        assignItem[key] = otherCb;
        Object.assign(queryParam, assignItem);
        let ckFlagItem = {};
        ckFlagItem[key] = false;
        Object.assign(ckFlag, ckFlagItem);
      } else {
        if (checkedValue[0] == 'all') {
          let assignItem = {};
          assignItem[key] = ['all'];
          Object.assign(queryParam, assignItem);
          let ckFlagItem = {};
          ckFlagItem[key] = true;
          Object.assign(ckFlag, ckFlagItem);
        }
      }
    }
  }
  //注册model
  const [registerModal, { openModal }] = useModal();
  const switchItems = ref(false);
  const complianeInfoRecord = ref({});
  const complianeClassVal = ref('');
  const route = useRoute();
  const router = useRouter();
  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '合规库',
      api: listAll,
      columns,
      canResize: false,
      showTableSetting: false,
      useSearchForm: false,
      //  formConfig: {
      //     //labelWidth: 120,
      //     schemas: searchFormSchema,
      //     autoSubmitOnEnter:true,
      //     showAdvancedButton:true,
      //     fieldMapToNumber: [
      //     ],
      //     fieldMapToTime: [
      //     ],
      //   },
      showActionColumn: true,
      //  actionColumn: {
      //      width: 200,
      //      fixed:'right'
      //   },
      beforeFetch(params) {
        params = Object.assign(params, { column: 'updatedTime', order: 'desc' });
      },
    },
    exportConfig: {
      name: '合规库',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
      success: handleSuccess,
    },
  });

  const [registerTable, { reload, setProps }, { rowSelection, selectedRowKeys }] = tableContext;
  //-----自定义查询----begin--------
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 8 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });
  const queryParam = reactive({});
  // function goToFile(record){
  //   if(!!record.fileUploadPath){
  //     let url = getFileAccessHttpUrl(record.fileUploadPath);
  //     window.open(url);
  //   }else{
  //     message.warning("无附件")
  //   }
  // }
  function initParam() {
    const schemas = unref(searchFormSchema);
    schemas.forEach((item) => {
      queryParam[item.field] = '';
    });
    queryParam['checkStatus'] = ['all'];
    queryParam['checkDates'] = ['all'];
    queryParam['checkClassifys'] = ['all'];
  }
  initParam();
  function searchQuery() {
    queryParam['complianeClass'] = complianeClassVal.value;
    setProps({ searchInfo: toRaw(queryParam) });
    reload();
  }
  function searchReset() {
    //Object.assign(queryParam,{ name: '',age_begin: '',age_end: '',sex: '',id: ''});
    initParam();
    reload();
  }
  function goToPage(record) {
    if (record.complianeClass == '1') {
      router.push({ path: '/standardlib/compliane/fl', query: { bizNo: record.complianeNo } });
    } else if (record.complianeClass == '2') {
      router.push({ path: '/standardlib/compliane/fg', query: { bizNo: record.complianeNo } });
    } else if (record.complianeClass == '3') {
      router.push({ path: '/standardlib/compliane/jg', query: { bizNo: record.complianeNo } });
    } else if (record.complianeClass == '4') {
      router.push({ path: '/standardlib/compliane/fx', query: { bizNo: record.complianeNo } });
    } else if (record.complianeClass == '5') {
      router.push({ path: '/standardlib/compliane/cf', query: { bizNo: record.complianeNo } });
    }
  }
  function getFileName(path) {
    if (path.lastIndexOf('\\') >= 0) {
      let reg = new RegExp('\\\\', 'g');
      path = path.replace(reg, '/');
    }
    return path.substring(path.lastIndexOf('/') + 1);
  }

  function uidGenerator() {
    return '-' + parseInt(Math.random() * 10000 + 1, 10);
  }
  // 解析数据库存储的逗号分割
  function parsePathsValue(paths) {
    console.log(paths);
    if (!paths || paths.length == 0) {
      return [];
    }
    let list: any[] = [];
    for (const item of paths.split(',')) {
      let url = getFileAccessHttpUrl(item);
      list.push({
        uid: uidGenerator(),
        name: getFileName(item),
        status: 'done',
        url: url,
        response: { status: 'history', message: item },
      });
    }
    return list;
  }
  //自定义查询----end---------
  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      complianeClass: complianeClassVal,
      isUpdate: false,
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: false,
    });
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }

  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      //  {
      //      label: '删除',
      //      color: 'error',
      //      popConfirm: {
      //        title: '是否确认删除',
      //        confirm: handleDelete.bind(null, record),
      //      }
      //    },
      //    {
      //      label: '修改',
      //      onClick: handleEdit.bind(null, record),
      //    },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      //    {
      //      label: '条目',
      //      onClick: handleItem.bind(null, record),
      //    },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [];
  }
</script>

<style scoped></style>
